# Contributing to Jep

## Build issues

Testing the build of Jep on the variety of possible platforms and environments
is difficult. It works well for Linux and OS X.  Building on Windows poses
unique challenges that have been documented on the [Windows wiki page](https://github.com/mrj0/jep/wiki/Windows).
Please consider documenting build troubles and solutions on the wiki to help
others.


## Seeking help

If you need help using Jep, please first search for existing issues, questions,
and documentation to see if your question has already been answered.  If you
can't find the solution, you may open an issue to ask questions.  Please be
detailed with information surrounding your problem.  Please close the issue
once the issue is solved to keep down the number of open issues.


## Reporting issues

When reporting bugs please include the Python version, Java version, and
operating system.  It is also helpful if you can recreate or simulate the
problem with a simple test with the Jep command line interpreter.


## Contributing code

If you're fixing an issue and it's not a lot of code, just go ahead and
create a pull request.  Please include information about the fix on an
issue, in the commit message, and/or in code comments.

New code submissions should be based on the latest dev_X.Y branch. The master
branch is only updated after a release and will contain the latest release.
New code will only be accepted on older dev_X.Y branches for stability fixes.

If you'd like to get more involved than just a fix here or there, then
please send the current developers a message.
